import {run} from 'madrun';

export default {
    'test': () => `supertape 'lib/**/*.spec.js'`,
    'test:dts': () => 'check-dts',
    'watch:test': async () => `nodemon -w lib -w test -x "${await run('test')}"`,
    'lint': () => 'putout .',
    'fresh:lint': () => run('lint', '--fresh'),
    'lint:fresh': () => run('lint', '--fresh'),
    'fix:lint': () => run('lint', '--fix'),
    'coverage': async () => `c8 ${await run('test')}`,
    'report': () => 'c8 report --reporter=lcov',
    'wisdom': () => run(['lint', 'coverage', 'test:dts']),
};
